//@flow
/**
 * @author Sven Koelpin
 */
import React, { PureComponent } from 'react';
import style from './userList.css';
import { User } from '../domain/Entities';

type Props = {|
    users: Array<User>;
|}

export class UserList extends PureComponent<void, Props, void> {

    render() {
        const {users} = this.props;
        return (
            <ul className={style.userList}>
                {
                    users.map(user => {
                        return <li key={user.id}>{user.online ? <span className={style.online}/> : <span className={style.offline}/>} {user.name}</li>
                    })
                }
            </ul>
        );
    }

}