//@flow
/**
 * @author Sven Koelpin
 */

import { AppSettings, Message, User } from '../domain/Entities';

let userListener;
let chatListener;

const randomUsers = (): Array<User> => {
    const users = [];
    for (let i = 1, length = 20; i <= length; i++) {
        users.push(new User(i, `User ${i}`, (i % 2) === 0));
    }
    return users;
};
const users = randomUsers();


const randomMessage = (): Message => {
    const user = users[Math.floor(Math.random() * (3))];
    return new Message(Date.now(), user.id, Date.now(), `Check out my message`);
};


export const get = (url: string) => {
    return new Promise(resolve => {
        setTimeout(() => {
            if (url === 'users') {
                return resolve(users.map(user => Object.assign(({}: any), user)));
            }
            if (url === 'users/1/settings') {
                return resolve(new AppSettings('en', '##.##', 'mm-dd-yyyy'));
            }
            if (url.startsWith('users/')) {
                const id = parseInt(url.split('/')[1]);
                return resolve(Object.assign(({}: any), users.find(user => user.id === id)));
            }
            return resolve();
        }, 100);
    });
};

export const subscribeToChatMessages = (listener: (message: Message) => void) => {
    listener(randomMessage());
    chatListener = setInterval(() => {
        listener(randomMessage());
    }, 5000);
};

export const unsubscribeAll = () => {
    clearInterval(userListener);
    clearInterval(chatListener);
};

export const unsubscribeChat = () => {
    clearInterval(chatListener);
};

export const unsubscribeUser = () => {
    clearInterval(userListener);
};

export const subscribeToUserChanges = (listener: (user: User) => void) => {
    userListener = setInterval(() => {
        const user = users[Math.floor(Math.random() * (3))];
        user.online = !user.online;
        listener(Object.assign(({}: any), user));

    }, 1000);
};